"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_root_siblings_1 = __importDefault(require("react-native-root-siblings"));
const react_native_1 = require("react-native");
const style_1 = __importDefault(require("./style"));
const react_native_camera_1 = require("react-native-camera");
const Button_1 = __importDefault(require("../Button"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Icons_1 = __importDefault(require("../Icons"));
const { height } = react_native_1.Dimensions.get('window');
let cameraView = undefined;
;
const CameraView = ({ onSubmit, }) => {
    const duration = 500;
    const fadeAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(height)).current;
    const fadeOut = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: height,
            duration,
            useNativeDriver: true
        }).start();
    };
    const fadeIn = () => {
        react_native_1.Animated.timing(fadeAnim, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
    };
    fadeIn();
    const onBack = () => {
        fadeOut();
        setTimeout(() => {
            cameraView === null || cameraView === void 0 ? void 0 : cameraView.destroy();
        }, duration);
    };
    const onPicture = (camera) => __awaiter(void 0, void 0, void 0, function* () {
        const options = {
            quality: 0.5,
            base64: true
        };
        const data = yield camera.takePictureAsync(options);
        onSubmit === null || onSubmit === void 0 ? void 0 : onSubmit(data);
        onBack();
    });
    return (react_1.default.createElement(react_native_1.Animated.View, { style: [
            style_1.default.animate,
            {
                transform: [{ translateY: fadeAnim }],
            }
        ] },
        react_1.default.createElement(react_native_camera_1.RNCamera, { style: style_1.default.camera, type: react_native_camera_1.RNCamera.Constants.Type.back, flashMode: react_native_camera_1.RNCamera.Constants.FlashMode.auto, androidCameraPermissionOptions: {
                title: '相机权限',
                message: '我们需要使用你的相机权限',
                buttonPositive: '确定',
                buttonNegative: '取消',
            } }, ({ camera, status }) => {
            if (status !== 'READY') {
                return (react_1.default.createElement(react_native_1.Text, null, "Waiting..."));
            }
            return (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(react_native_1.SafeAreaView, null,
                    react_1.default.createElement(react_native_1.View, { style: style_1.default.header },
                        react_1.default.createElement(Button_1.default, { styleContainer: style_1.default.headerLeft, onPress: onBack },
                            react_1.default.createElement(Icons_1.default, { name: 'arrowLeft', size: 16, color: '#fff' })),
                        react_1.default.createElement(react_native_1.View, { style: style_1.default.headerMid },
                            react_1.default.createElement(react_native_1.Text, { style: style_1.default.headerText }, "\u62CD\u7167")),
                        react_1.default.createElement(react_native_1.View, { style: style_1.default.headerRight }))),
                react_1.default.createElement(react_native_1.View, { style: { flex: 1 } }),
                react_1.default.createElement(react_native_1.SafeAreaView, { style: style_1.default.footer },
                    react_1.default.createElement(IconButton_1.default, { styleContainer: style_1.default.footerButton, styleText: style_1.default.footerText, name: 'camera', color: '#fff', size: 40, onPress: () => {
                            onPicture === null || onPicture === void 0 ? void 0 : onPicture(camera);
                        } }))));
        })));
};
const Camera = (_a) => {
    var props = __rest(_a, []);
    cameraView === null || cameraView === void 0 ? void 0 : cameraView.destroy();
    cameraView = new react_native_root_siblings_1.default(react_1.default.createElement(CameraView, Object.assign({}, props)));
};
exports.default = Camera;
