"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const Config_1 = __importDefault(require("@components/Config"));
const Loading_1 = __importDefault(require("../Loading"));
const Toast_1 = __importDefault(require("../Toast"));
const Fetch = (url, params = {}, extend = {}) => {
    const opts = {
        url,
        method: (extend && (extend === null || extend === void 0 ? void 0 : extend.method)) || 'post',
        baseURL: !/http/.test(url) ? Config_1.default.apiHost : '',
        headers: Object.assign({ 'content-type': 'application/json' }, extend.headers),
        timeout: 30000,
        withCredentials: true,
        responseType: 'json',
        responseEncoding: 'utf8',
        maxContentLength: 2000,
    };
    if (opts.method.toLowerCase() === 'post')
        opts.data = Object.assign({}, params);
    if (opts.method.toLowerCase() === 'get')
        opts.params = Object.assign({}, params);
    const ext = {
        loading: (extend && extend.loading === false) ? false : true,
        toast: (extend && extend.toast === false) ? false : true,
    };
    (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.show();
    return new Promise((resolve, reject) => {
        (0, axios_1.default)(opts).then(res => {
            console.log(`res___________${opts.baseURL + opts.url}\n`);
            (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.hide();
            if (res && res.data && res.data.success) {
                console.log('res__________success_true');
                resolve(res.data.result);
            }
            else {
                console.log('res__________success_false');
                reject(res.data);
            }
        }).catch((err) => {
            (ext === null || ext === void 0 ? void 0 : ext.loading) && Loading_1.default.hide();
            console.log(`err___________${opts.baseURL + opts.url}\n`);
            if (ext === null || ext === void 0 ? void 0 : ext.toast)
                Toast_1.default.show((err === null || err === void 0 ? void 0 : err.message) || '网络繁忙，请稍后再试！');
            reject(err);
        });
    });
};
exports.default = Fetch;
