"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_root_siblings_1 = __importDefault(require("react-native-root-siblings"));
const react_native_1 = require("react-native");
const IconButton_1 = __importDefault(require("../IconButton"));
const Icons_1 = __importDefault(require("../Icons"));
const react_native_image_zoom_viewer_1 = __importDefault(require("react-native-image-zoom-viewer"));
const styles_1 = __importDefault(require("./styles"));
let previewView = undefined;
const PreviewView = ({ images = [], index = 0, }) => {
    const [show, setShow] = (0, react_1.useState)(true);
    const [photo, setPhoto] = (0, react_1.useState)([]);
    const fadeAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(0)).current;
    (0, react_1.useEffect)(() => {
        setPhoto(images);
        return setDestroy;
    }, [images]);
    const setDestroy = () => {
        setPhoto([]);
    };
    const startAnimate = () => {
        const animationSlider = react_native_1.Animated.sequence([
            react_native_1.Animated.timing(fadeAnim, {
                toValue: 200,
                duration: 30000,
                useNativeDriver: true,
                easing: react_native_1.Easing.bezier(0, 0, 1, 1),
            }),
        ]);
        react_native_1.Animated.loop(animationSlider).start();
    };
    const _onClose = () => {
        previewView === null || previewView === void 0 ? void 0 : previewView.destroy();
        previewView = undefined;
    };
    const _onCancel = () => {
        setShow(false);
        _onClose();
    };
    const Header = (index, allSize) => {
        return (react_1.default.createElement(react_native_1.SafeAreaView, { style: styles_1.default.header },
            react_1.default.createElement(react_native_1.View, { style: styles_1.default.headerBtn }),
            react_1.default.createElement(react_native_1.View, { style: styles_1.default.headerMid },
                react_1.default.createElement(react_native_1.Text, { style: styles_1.default.headerText },
                    index,
                    " / ",
                    allSize)),
            react_1.default.createElement(IconButton_1.default, { styleContainer: [styles_1.default.headerBtn], name: 'close', size: 22, color: '#fff', onPress: _onCancel })));
    };
    const Footer = (index) => {
        var _a;
        const text = ((_a = photo === null || photo === void 0 ? void 0 : photo[index || 0]) === null || _a === void 0 ? void 0 : _a.text) || '';
        if (!text)
            return react_1.default.createElement(react_1.default.Fragment, null);
        return (react_1.default.createElement(react_native_1.View, { style: styles_1.default.footer },
            react_1.default.createElement(react_native_1.Text, { style: styles_1.default.footerText }, text)));
    };
    const Loading = () => {
        startAnimate();
        return (react_1.default.createElement(react_native_1.Animated.View, { style: [
                styles_1.default.animate,
                { transform: [{ rotate: fadeAnim }] }
            ] },
            react_1.default.createElement(Icons_1.default, { name: 'loading', color: '#999', size: 40 })));
    };
    const renderView = () => {
        if (!(photo === null || photo === void 0 ? void 0 : photo.length))
            return null;
        return (react_1.default.createElement(react_native_1.Modal, { visible: show, transparent: true },
            react_1.default.createElement(react_native_image_zoom_viewer_1.default, { imageUrls: photo, index: index, saveToLocalByLongPress: false, loadingRender: () => react_1.default.createElement(Loading, null), renderFooter: (index) => Footer(index), renderIndicator: (index, allSize) => Header(index, allSize), enableSwipeDown: true, swipeDownThreshold: 200, onSwipeDown: () => {
                    _onCancel();
                } })));
    };
    return renderView();
};
const ImagePreview = (_a) => {
    var props = __rest(_a, []);
    previewView === null || previewView === void 0 ? void 0 : previewView.destroy();
    previewView = new react_native_root_siblings_1.default(react_1.default.createElement(PreviewView, Object.assign({}, props)));
};
exports.default = ImagePreview;
